- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::PardisoSolverInterface Class Reference

Interface to the linear solver Pardiso, derived from SparseSymLinearSolverInterface. More...

`#include <IpPardisoSolverInterface.hpp>`

Inheritance diagram for Ipopt::PardisoSolverInterface:

[legend]
Collaboration diagram for Ipopt::PardisoSolverInterface:

[legend]
List of all members.

## Solver specific options
enum | PardisoMatchingStrategy { COMPLETE, COMPLETE2x2, CONSTRAINT }
| Type for mathcing strategies. More...
PardisoMatchingStrategy | match_strat_
| Option that controls the matching strategy.
bool | have_symbolic_factorization_
| Flag indicating if symbolic factorization has already been performed.
bool | pardiso_redo_symbolic_fact_only_if_inertia_wrong_
| Flag indicating whether the symbolic factorization should only be done after perturbed elements, if the inertia was wrong.
bool | pardiso_repeated_perturbation_means_singular_
| Flag indicating whether repeated perturbed elements even after a new symbolic factorization should be interpreted as a singular matrix.
## Public Member Functions
bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| overloaded from AlgorithmStrategyObject
Constructor/Destructor
| PardisoSolverInterface ()
| Constructor.
virtual | ~PardisoSolverInterface ()
| Destructor.
Methods for requesting solution of the linear system.
virtual ESymSolverStatus | InitializeStructure (Index dim, Index nonzeros, const Index *ia, const Index *ja)
| Method for initializing internal stuctures.
virtual double * | GetValuesArrayPtr ()
| Method returing an internal array into which the nonzero elements are to be stored.
virtual ESymSolverStatus | MultiSolve (bool new_matrix, const Index *ia, const Index *ja, Index nrhs, double *rhs_vals, bool check_NegEVals, Index numberOfNegEVals)
| Solve operation for multiple right hand sides.
virtual Index | NumberOfNegEVals () const
| Number of negative eigenvalues detected during last factorization.
virtual bool | IncreaseQuality ()
| Request to increase quality of solution for next solve.
virtual bool | ProvidesInertia () const
| Query whether inertia is computed by linear solver.
EMatrixFormat | MatrixFormat () const
| Query of requested matrix type that the linear solver understands.
## Static Public Member Functions
static void | RegisterOptions (SmartPtr< RegisteredOptions > roptions)
| Methods for IpoptType.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| PardisoSolverInterface (const PardisoSolverInterface &)
| Copy Constructor.
void | operator= (const PardisoSolverInterface &)
| Overloaded Equals Operator.
Internal functions
ESymSolverStatus | SymbolicFactorization (const Index *ia, const Index *ja)
| Call Pardiso to do the analysis phase.
ESymSolverStatus | Factorization (const Index *ia, const Index *ja, bool check_NegEVals, Index numberOfNegEVals)
| Call Pardiso to factorize the Matrix.
ESymSolverStatus | Solve (const Index *ia, const Index *ja, Index nrhs, double *rhs_vals)
| Call Pardiso to do the Solve.
## Private Attributes
Information about the matrix
Index | dim_
| Number of rows and columns of the matrix.
Index | nonzeros_
| Number of nonzeros of the matrix in triplet representation.
double * | a_
| Array for storing the values of the matrix.
Information about most recent factorization/solve
Index | negevals_
| Number of negative eigenvalues.
Initialization flags
bool | initialized_
| Flag indicating if internal data is initialized.
Solver specific information
void ** | PT_
| Internal data address pointers.
ipfint | MAXFCT_
| Maximal number of factors with identical nonzero structure.
ipfint | MNUM_
| Actual matrix for the solution phase.
ipfint | MTYPE_
| Matrix type; real and symmetric indefinite.
ipfint * | IPARM_
| Parameter and info array for Pardiso.
ipfint | MSGLVL_
| Message level.
Some counters for debugging
Index | debug_last_iter_
Index | debug_cnt_

## Detailed Description

Interface to the linear solver Pardiso, derived from SparseSymLinearSolverInterface.

For details, see description of SparseSymLinearSolverInterface base class.

Definition at line 22 of file IpPardisoSolverInterface.hpp.

## Member Enumeration Documentation

enum Ipopt::PardisoSolverInterface::PardisoMatchingStrategy`[private]`

Type for mathcing strategies.

Enumerator:

  COMPLETE |
  COMPLETE2x2 |
  CONSTRAINT |

Definition at line 129 of file IpPardisoSolverInterface.hpp.

## Constructor & Destructor Documentation

Ipopt::PardisoSolverInterface::PardisoSolverInterface | ( |  | ) |

Constructor.

virtual Ipopt::PardisoSolverInterface::~PardisoSolverInterface | ( |  | ) | `[virtual]`

Destructor.

Ipopt::PardisoSolverInterface::PardisoSolverInterface | ( | const PardisoSolverInterface & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

bool Ipopt::PardisoSolverInterface::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::PardisoSolverInterface::InitializeStructure | ( | Index | dim,
|  | Index | nonzeros,
|  | const Index * | ia,
|  | const Index * | ja |
| ) |  |  | `[virtual]`

Method for initializing internal stuctures.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual double* Ipopt::PardisoSolverInterface::GetValuesArrayPtr | ( |  | ) | `[virtual]`

Method returing an internal array into which the nonzero elements are to be stored.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::PardisoSolverInterface::MultiSolve | ( | bool | new_matrix,
|  | const Index * | ia,
|  | const Index * | ja,
|  | Index | nrhs,
|  | double * | rhs_vals,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[virtual]`

Solve operation for multiple right hand sides.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual Index Ipopt::PardisoSolverInterface::NumberOfNegEVals | ( |  | ) | const`[virtual]`

Number of negative eigenvalues detected during last factorization.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::PardisoSolverInterface::IncreaseQuality | ( |  | ) | `[virtual]`

Request to increase quality of solution for next solve.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::PardisoSolverInterface::ProvidesInertia | ( |  | ) | const`[inline, virtual]`

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 74 of file IpPardisoSolverInterface.hpp.

EMatrixFormat Ipopt::PardisoSolverInterface::MatrixFormat | ( |  | ) | const`[inline, virtual]`

Query of requested matrix type that the linear solver understands.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 81 of file IpPardisoSolverInterface.hpp.

References Ipopt::SparseSymLinearSolverInterface::CSR_Format_1_Offset.

static void Ipopt::PardisoSolverInterface::RegisterOptions | ( | SmartPtr< RegisteredOptions > | roptions | ) | `[static]`

Methods for IpoptType.

void Ipopt::PardisoSolverInterface::operator= | ( | const PardisoSolverInterface & |  | ) | `[private]`

Overloaded Equals Operator.

ESymSolverStatus Ipopt::PardisoSolverInterface::SymbolicFactorization | ( | const Index * | ia,
|  | const Index * | ja |
| ) |  |  | `[private]`

Call Pardiso to do the analysis phase.

ESymSolverStatus Ipopt::PardisoSolverInterface::Factorization | ( | const Index * | ia,
|  | const Index * | ja,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[private]`

Call Pardiso to factorize the Matrix.

ESymSolverStatus Ipopt::PardisoSolverInterface::Solve | ( | const Index * | ia,
|  | const Index * | ja,
|  | Index | nrhs,
|  | double * | rhs_vals |
| ) |  |  | `[private]`

Call Pardiso to do the Solve.

## Member Data Documentation

Index Ipopt::PardisoSolverInterface::dim_`[private]`

Number of rows and columns of the matrix.

Definition at line 111 of file IpPardisoSolverInterface.hpp.

Index Ipopt::PardisoSolverInterface::nonzeros_`[private]`

Number of nonzeros of the matrix in triplet representation.

Definition at line 114 of file IpPardisoSolverInterface.hpp.

double* Ipopt::PardisoSolverInterface::a_`[private]`

Array for storing the values of the matrix.

Definition at line 117 of file IpPardisoSolverInterface.hpp.

Index Ipopt::PardisoSolverInterface::negevals_`[private]`

Number of negative eigenvalues.

Definition at line 123 of file IpPardisoSolverInterface.hpp.

PardisoMatchingStrategy Ipopt::PardisoSolverInterface::match_strat_`[private]`

Option that controls the matching strategy.

Definition at line 135 of file IpPardisoSolverInterface.hpp.

bool Ipopt::PardisoSolverInterface::have_symbolic_factorization_`[private]`

Flag indicating if symbolic factorization has already been performed.

Definition at line 138 of file IpPardisoSolverInterface.hpp.

bool Ipopt::PardisoSolverInterface::pardiso_redo_symbolic_fact_only_if_inertia_wrong_`[private]`

Flag indicating whether the symbolic factorization should only be done after perturbed elements, if the inertia was wrong.

Definition at line 141 of file IpPardisoSolverInterface.hpp.

bool Ipopt::PardisoSolverInterface::pardiso_repeated_perturbation_means_singular_`[private]`

Flag indicating whether repeated perturbed elements even after a new symbolic factorization should be interpreted as a singular matrix.

Definition at line 145 of file IpPardisoSolverInterface.hpp.

bool Ipopt::PardisoSolverInterface::initialized_`[private]`

Flag indicating if internal data is initialized.

For initialization, this object needs to have seen a matrix

Definition at line 152 of file IpPardisoSolverInterface.hpp.

void** Ipopt::PardisoSolverInterface::PT_`[private]`

Internal data address pointers.

Definition at line 158 of file IpPardisoSolverInterface.hpp.

ipfint Ipopt::PardisoSolverInterface::MAXFCT_`[private]`

Maximal number of factors with identical nonzero structure.

Here, we only store one factorization. Is always 1.

Definition at line 161 of file IpPardisoSolverInterface.hpp.

ipfint Ipopt::PardisoSolverInterface::MNUM_`[private]`

Actual matrix for the solution phase.

Is always 1.

Definition at line 163 of file IpPardisoSolverInterface.hpp.

ipfint Ipopt::PardisoSolverInterface::MTYPE_`[private]`

Matrix type; real and symmetric indefinite.

Is always -2.

Definition at line 165 of file IpPardisoSolverInterface.hpp.

ipfint* Ipopt::PardisoSolverInterface::IPARM_`[private]`

Parameter and info array for Pardiso.

Definition at line 167 of file IpPardisoSolverInterface.hpp.

ipfint Ipopt::PardisoSolverInterface::MSGLVL_`[private]`

Message level.

Definition at line 169 of file IpPardisoSolverInterface.hpp.

Index Ipopt::PardisoSolverInterface::debug_last_iter_`[private]`

Definition at line 174 of file IpPardisoSolverInterface.hpp.

Index Ipopt::PardisoSolverInterface::debug_cnt_`[private]`

Definition at line 175 of file IpPardisoSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.2.1/Ipopt/src/Algorithm/LinearSolvers/IpPardisoSolverInterface.hpp